您的位置:首页 > 运维架构

HDU 3853 LOOPS(概率DP简单题)

2016-03-09 21:35 405 查看
题目链接:点击打开链接


LOOPS

Time Limit: 15000/5000 MS (Java/Others) Memory Limit: 125536/65536 K (Java/Others)

Total Submission(s): 4374 Accepted Submission(s): 1744



Problem Description

Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.



The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the
right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!

At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power
she need to escape from the LOOPS.

Input

The first line contains two integers R and C (2 <= R, C <= 1000).

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1,
c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

You may ignore the last three numbers of the input data. They are printed just for looking neat.

The answer is ensured no greater than 1000000.

Terminal at EOF

Output

A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

Sample Input

2 2
0.00 0.50 0.50    0.50 0.00 0.50
0.50 0.50 0.00    1.00 0.00 0.00


Sample Output

6.000


Source

2011 Invitational Contest Host by BUPT

题意:r*c的矩阵,从左上角走到右下角,每次可以向下,向右和在原地,消耗的能量均为2,给出在矩阵的所有位置走这三种的概率,求走到终点消耗值的期望。

思路:dp[i][j]表示从点(i,j)走到终点的消耗值,则dp[i][j]=(p1*dp[i][j]+p2*dp[i][j+1]+p3*dp[i+1][j]+2),所以dp[i][j]=(p1*dp[i][j]+p2*dp[i][j+1]+2)/(1-p3);p1,p2,p3是原地、向右、向下的概率。

AC代码:

#include<stdio.h>
#include<string.h>
struct node
{
double p1,p2,p3;
}a[1010][1010];
double dp[1010][1010];
int main()
{
int r,c,i,j;
while(scanf("%d%d",&r,&c)!=EOF)
{
memset(dp,0,sizeof(dp));
for(i=1;i<=r;i++)
for(j=1;j<=c;j++)
scanf("%lf%lf%lf",&a[i][j].p1,&a[i][j].p2,&a[i][j].p3);
for(i=r;i>=1;i--)
for(j=c;j>=1;j--)
if(i==r&&j==c||a[i][j].p1==1) continue;
else dp[i][j]=(a[i][j].p2*dp[i][j+1]+a[i][j].p3*dp[i+1][j]+2)/(1-a[i][j].p1);
printf("%.3lf\n",dp[1][1]);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: